diff --git a/resolv/gethnamaddr.c b/resolv/gethnamaddr.c
index 4720fc8..2e92df8 100644
--- a/resolv/gethnamaddr.c
+++ b/resolv/gethnamaddr.c
@@ -54,10 +54,6 @@
    it exports symbols in the libresolv ABI.  The file is not maintained any
    more, nor are these functions.  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static char sccsid[] = "@(#)gethostnamadr.c	8.1 (Berkeley) 6/4/93";
-#endif /* LIBC_SCCS and not lint */
-
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/socket.h>
diff --git a/resolv/herror.c b/resolv/herror.c
index 0aaf29f..e285224 100644
--- a/resolv/herror.c
+++ b/resolv/herror.c
@@ -44,11 +44,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char sccsid[] = "@(#)herror.c	8.1 (Berkeley) 6/4/93";
-static const char rcsid[] = "$BINDId: herror.c,v 8.11 1999/10/13 16:39:39 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/uio.h>
diff --git a/resolv/inet_addr.c b/resolv/inet_addr.c
index ee42093..a16b513 100644
--- a/resolv/inet_addr.c
+++ b/resolv/inet_addr.c
@@ -64,11 +64,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char sccsid[] = "@(#)inet_addr.c	8.1 (Berkeley) 6/17/93";
-static const char rcsid[] = "$BINDId: inet_addr.c,v 8.11 1999/10/13 16:39:25 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 #include <sys/types.h>
 #include <sys/param.h>
 
diff --git a/resolv/inet_net_ntop.c b/resolv/inet_net_ntop.c
index 2d57ae3..aaa78f6 100644
--- a/resolv/inet_net_ntop.c
+++ b/resolv/inet_net_ntop.c
@@ -15,10 +15,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char rcsid[] = "$BINDId: inet_net_ntop.c,v 1.6 1999/01/08 19:23:42 vixie Exp $";
-#endif
-
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
diff --git a/resolv/inet_net_pton.c b/resolv/inet_net_pton.c
index 75a8515..aab9b7b 100644
--- a/resolv/inet_net_pton.c
+++ b/resolv/inet_net_pton.c
@@ -15,10 +15,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char rcsid[] = "$BINDId: inet_net_pton.c,v 1.11 1999/01/08 19:23:44 vixie Exp $";
-#endif
-
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
diff --git a/resolv/inet_neta.c b/resolv/inet_neta.c
index b9f256b..348ff47 100644
--- a/resolv/inet_neta.c
+++ b/resolv/inet_neta.c
@@ -15,10 +15,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char rcsid[] = "$BINDId: inet_neta.c,v 1.6 1999/01/08 19:23:45 vixie Exp $";
-#endif
-
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
diff --git a/resolv/inet_ntop.c b/resolv/inet_ntop.c
index 32338c5..01c45ce 100644
--- a/resolv/inet_ntop.c
+++ b/resolv/inet_ntop.c
@@ -15,10 +15,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char rcsid[] = "$BINDId: inet_ntop.c,v 1.8 1999/10/13 16:39:28 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 #include <sys/param.h>
 #include <sys/types.h>
 #include <sys/socket.h>
diff --git a/resolv/inet_pton.c b/resolv/inet_pton.c
index 0d18e9a..c0a7d54 100644
--- a/resolv/inet_pton.c
+++ b/resolv/inet_pton.c
@@ -15,10 +15,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char rcsid[] = "$BINDId: inet_pton.c,v 1.7 1999/10/13 16:39:28 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 #include <sys/param.h>
 #include <sys/types.h>
 #include <sys/socket.h>
diff --git a/resolv/ns_date.c b/resolv/ns_date.c
index 9801ac4..31cef74 100644
--- a/resolv/ns_date.c
+++ b/resolv/ns_date.c
@@ -15,10 +15,6 @@
  * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
-#if !defined(_LIBC) && !defined(lint)
-static const char rcsid[] = "$Id$";
-#endif
-
 /* Import. */
 
 #include <arpa/nameser.h>
diff --git a/resolv/ns_name.c b/resolv/ns_name.c
index f355cf3..65e7fc8 100644
--- a/resolv/ns_name.c
+++ b/resolv/ns_name.c
@@ -15,10 +15,6 @@
  * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
-#if !defined(_LIBC) && !defined(lint)
-static const char rcsid[] = "$BINDId: ns_name.c,v 8.15 2000/03/30 22:53:46 vixie Exp $";
-#endif
-
 #include <sys/types.h>
 
 #include <netinet/in.h>
diff --git a/resolv/ns_netint.c b/resolv/ns_netint.c
index 4318f18..6a365a3 100644
--- a/resolv/ns_netint.c
+++ b/resolv/ns_netint.c
@@ -15,10 +15,6 @@
  * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
-#if !defined(_LIBC) && !defined(lint)
-static const char rcsid[] = "$BINDId: ns_netint.c,v 8.4 1999/10/13 16:39:35 vixie Exp $";
-#endif
-
 /* Import. */
 
 #include <arpa/nameser.h>
diff --git a/resolv/ns_parse.c b/resolv/ns_parse.c
index 712469b..863b20a 100644
--- a/resolv/ns_parse.c
+++ b/resolv/ns_parse.c
@@ -15,10 +15,6 @@
  * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
-#if !defined(_LIBC) && !defined(lint)
-static const char rcsid[] = "$BINDId: ns_parse.c,v 8.13 1999/10/13 16:39:35 vixie Exp $";
-#endif
-
 /* Import. */
 
 #include <sys/types.h>
diff --git a/resolv/ns_print.c b/resolv/ns_print.c
index 800680d..7a0e7d5 100644
--- a/resolv/ns_print.c
+++ b/resolv/ns_print.c
@@ -16,10 +16,6 @@
  * SOFTWARE.
  */
 
-#if !defined(_LIBC) && !defined(lint)
-static const char rcsid[] = "$BINDId: ns_print.c,v 8.18 2000/02/29 05:48:12 vixie Exp $";
-#endif
-
 /* Import. */
 
 #include <sys/types.h>
diff --git a/resolv/ns_samedomain.c b/resolv/ns_samedomain.c
index df6a4a2..5d1bf39 100644
--- a/resolv/ns_samedomain.c
+++ b/resolv/ns_samedomain.c
@@ -16,10 +16,6 @@
  * SOFTWARE.
  */
 
-#if !defined(_LIBC) && !defined(lint)
-static const char rcsid[] = "$BINDId: ns_samedomain.c,v 8.9 1999/10/15 21:06:51 vixie Exp $";
-#endif
-
 #include <sys/types.h>
 #include <arpa/nameser.h>
 #include <errno.h>
diff --git a/resolv/ns_ttl.c b/resolv/ns_ttl.c
index d4c98bc..0799487 100644
--- a/resolv/ns_ttl.c
+++ b/resolv/ns_ttl.c
@@ -16,10 +16,6 @@
  * SOFTWARE.
  */
 
-#if !defined(_LIBC) && !defined(lint)
-static const char rcsid[] = "$BINDId: ns_ttl.c,v 8.8 1999/10/13 16:39:36 vixie Exp $";
-#endif
-
 /* Import. */
 
 #include <arpa/nameser.h>
diff --git a/resolv/nsap_addr.c b/resolv/nsap_addr.c
index 7041e52..9a1d3f7 100644
--- a/resolv/nsap_addr.c
+++ b/resolv/nsap_addr.c
@@ -15,10 +15,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char rcsid[] = "$BINDId: nsap_addr.c,v 8.10 1999/10/13 16:39:28 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/socket.h>
diff --git a/resolv/res_comp.c b/resolv/res_comp.c
index 2ff7ddb..3c50774 100644
--- a/resolv/res_comp.c
+++ b/resolv/res_comp.c
@@ -64,11 +64,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char sccsid[] = "@(#)res_comp.c	8.1 (Berkeley) 6/4/93";
-static const char rcsid[] = "$BINDId: res_comp.c,v 8.15 1999/10/13 16:39:39 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 #include <sys/types.h>
 #include <sys/param.h>
 #include <netinet/in.h>
diff --git a/resolv/res_data.c b/resolv/res_data.c
index 81c9ae5..f7ec21e 100644
--- a/resolv/res_data.c
+++ b/resolv/res_data.c
@@ -15,10 +15,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char rcsid[] = "$BINDId: res_data.c,v 8.17 1999/10/13 17:11:31 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/socket.h>
diff --git a/resolv/res_debug.c b/resolv/res_debug.c
index 68a407a..d1e12db 100644
--- a/resolv/res_debug.c
+++ b/resolv/res_debug.c
@@ -89,11 +89,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char sccsid[] = "@(#)res_debug.c	8.1 (Berkeley) 6/4/93";
-static const char rcsid[] = "$BINDId: res_debug.c,v 8.34 2000/02/29 05:30:55 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/socket.h>
diff --git a/resolv/res_init.c b/resolv/res_init.c
index 02590fb..4fb7f1e 100644
--- a/resolv/res_init.c
+++ b/resolv/res_init.c
@@ -64,11 +64,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char sccsid[] = "@(#)res_init.c	8.1 (Berkeley) 6/7/93";
-static const char rcsid[] = "$BINDId: res_init.c,v 8.16 2000/05/09 07:10:12 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 #include <ctype.h>
 #include <netdb.h>
 #include <resolv.h>
diff --git a/resolv/res_mkquery.c b/resolv/res_mkquery.c
index 1635e6a..200b59f 100644
--- a/resolv/res_mkquery.c
+++ b/resolv/res_mkquery.c
@@ -64,11 +64,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char sccsid[] = "@(#)res_mkquery.c	8.1 (Berkeley) 6/4/93";
-static const char rcsid[] = "$BINDId: res_mkquery.c,v 8.12 1999/10/13 16:39:40 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 #include <sys/types.h>
 #include <sys/param.h>
 #include <netinet/in.h>
diff --git a/resolv/res_query.c b/resolv/res_query.c
index 95470a9..944d1a9 100644
--- a/resolv/res_query.c
+++ b/resolv/res_query.c
@@ -64,11 +64,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char sccsid[] = "@(#)res_query.c	8.1 (Berkeley) 6/4/93";
-static const char rcsid[] = "$BINDId: res_query.c,v 8.20 2000/02/29 05:39:12 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 #include <assert.h>
 #include <sys/types.h>
 #include <sys/param.h>
diff --git a/resolv/res_send.c b/resolv/res_send.c
index 2c0bae1..869294f 100644
--- a/resolv/res_send.c
+++ b/resolv/res_send.c
@@ -81,11 +81,6 @@
  * SOFTWARE.
  */
 
-#if defined(LIBC_SCCS) && !defined(lint)
-static const char sccsid[] = "@(#)res_send.c	8.1 (Berkeley) 6/4/93";
-static const char rcsid[] = "$BINDId: res_send.c,v 8.38 2000/03/30 20:16:51 vixie Exp $";
-#endif /* LIBC_SCCS and not lint */
-
 /*
  * Send query to name server and wait for reply.
  */